unit InsertDlg;

interface

uses
  Windows, Messages, SysUtils, Dialogs, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, BackPropNet;

type
  TInsertDialog = class(TForm)
    CancelBtn: TButton;
    OKBtn: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Box2: TComboBox;
    Box1: TComboBox;
    procedure Box1Change(Sender: TObject);
    procedure Box2Change(Sender: TObject);
    procedure OKBtnClick(Sender: TObject);
  private
    { Private-Deklarationen }
    FTask: Integer;
    NeuroNet: TBackPropNet;
    LayerIndex: Integer;
    NeuronIndex: Integer;
  public
    { Public-Deklarationen }
    constructor CreateWithParam(AOwner: TComponent; Net: TBackPropNet; Task: Integer);
  end;

var
  InsertDialog: TInsertDialog;

implementation
{$R *.DFM}

constructor TInsertDialog.CreateWithParam(AOwner: TComponent; Net: TBackPropNet; Task: Integer);
var I: Integer;
begin
  inherited Create(AOwner);
  FTask := Task;
  NeuroNet := Net;
  for I := 0 to (NeuroNet.LayerNo - 1) do
    Box1.Items.Add(IntToStr(I));
  Box1.ItemIndex := 0;
  case FTask of
    0: begin
         Box1.Items.Add(IntToStr(NeuroNet.LayerNo));
         Box2.Style := csSimple;
         Box2.Text := '1';
       end;
    1: begin
         Caption := 'Schicht lschen';
         Label1.Caption := 'Lsche Schicht mit Index';
         Label2.Caption := ' ?';
         Box2.TabStop := False;
         Box2.Visible := False;
         Label3.Visible := False;
         Label1.Left := 90;
         Box1.Left := Label1.Left + Label1.Width + 10;
         Label2.Left := Box1.Left + Box1.Width + 10;
         Exit;
       end;
    2: begin
         Caption := 'Neuron einfgen';
         Label1.Caption := 'Fge Neuron mit Index';
         Label1.Left := 25;
         Label2.Caption := 'in Schicht';
         Label3.Caption := 'ein ?';
         Box1Change(Self);
       end;
    3: begin
         Caption := 'Neuron lschen';
         Label1.Caption := 'Lsche Neuron mit Index';
         Label1.Left := 25;
         Label2.Caption := 'aus Schicht';
         Label3.Caption := ' ?';
         Box1Change(Self);
       end;
  end;
  Box2.Left := Label1.Left + Label1.Width + 10;
  Label2.Left := Box2.Left + Box2.Width + 10;
  Box1.Left := Label2.Left + Label2.Width + 10;
  Label3.Left := Box1.Left + Box1.Width + 10;
end;

procedure TInsertDialog.Box1Change(Sender: TObject);
var I: Integer;
begin
  if FTask > 1 then begin
    with NeuroNet[Box1.ItemIndex] do begin
      for I := 0 to (NeuronNo - 1) do
        Box2.Items.Add(IntToStr(I));
      if FTask = 1 then
        Box2.Items.Add(IntToStr(NeuronNo));
    end;
    Box2.ItemIndex := 0;
  end;
end;

procedure TInsertDialog.Box2Change(Sender: TObject);
var a: Integer;
begin
  if FTask = 0 then begin
    if Box2.Text = '' then Exit;
    try
      a := StrToInt(Box2.Text);
      if a < 1 then begin
        Box2.Text := '1';
        raise Exception.Create('Schicht mu mindestens ein Neuron enthalten');
      end;
    except
      on EConvertError do begin
        MessageDlg('''' + Box2.Text + '''' + ' ist kein gltiger Integerwert.', mtError, [mbOK], 0);
        Box2.Text := '1';
      end;
    end;
  end;
end;

procedure TInsertDialog.OKBtnClick(Sender: TObject);
var I: Integer;
begin
  LayerIndex := StrToInt(Box1.Text);
  if FTask <> 1 then
    NeuronIndex := StrToInt(Box2.Text);
  with NeuroNet do begin
    for I := 0 to (LayerNo - 1) do
      Items[I].Selected := False;
    case FTask of
      0: begin
           InsertLayer(LayerIndex, NeuronIndex);
           Items[LayerIndex].Selected := True;
         end;
      1: begin
           DeleteLayer(LayerIndex);
           Items[0].Selected := True;
         end;
      2: begin
           InsertNeuron(LayerIndex, NeuronIndex);
           Items[LayerIndex].Selected := True;
         end;
      3: begin
           if Items[LayerIndex].NeuronNo = 1 then
             raise Exception.Create('Kann Neuron in dieser Schicht nicht lschen.'
                + #13#10 + ' Jede Schicht mu mindestens ein Neuron enthalten');
           DeleteNeuron(LayerIndex, NeuronIndex);
           Items[LayerIndex].Selected := True;
         end;
    end;
  end;
  ModalResult := mrOK;
end;

end.



