unit SelectDlg;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms,
  StdCtrls, ExtCtrls, BackPropNet;

type
  TSelectDialog = class(TForm)
    CancelBtn: TButton;
    ListBox1: TListBox;
    OKBtn: TButton;
    Panel1: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    SelectAllBtn: TButton;
    procedure ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
                                Shift: TShiftState; X, Y: Integer);
    procedure OKBtnClick(Sender: TObject);
    procedure SelectAllBtnClick(Sender: TObject);
    procedure ListBox1DblClick(Sender: TObject);
  private
    NeuroNet: TBackPropNet;
  public
    constructor CreateWithParam(AOwner: TComponent; Net: TBackPropNet);
  end;

var
  SelectDialog: TSelectDialog;

implementation
{$R *.DFM}

constructor TSelectDialog.CreateWithParam(AOwner: TComponent; Net: TBackPropNet);
var I: Integer;
begin
  inherited Create(AOwner);
  NeuroNet := Net;
  for I := 0 to (NeuroNet.LayerNo - 1) do begin
    ListBox1.Items.Add('Schicht ' + IntToStr(I));
    ListBox1.Selected[I] := NeuroNet[I].Selected;
  end;
end;

procedure TSelectDialog.ListBox1DblClick(Sender: TObject);
begin
  OKBtnClick(Self);
end;

procedure TSelectDialog.ListBox1MouseDown(Sender: TObject; Button: TMouseButton;
                                          Shift: TShiftState; X, Y: Integer);
var APoint: TPoint;
begin
  if ssCtrl in Shift then begin
    APoint.X := X;
    APoint.Y := Y;
    with ListBox1 do
     if SelCount = 0 then
       Selected[ItemAtPos(APoint,False)] := True;
  end;
end;

procedure TSelectDialog.OKBtnClick(Sender: TObject);
var I: Integer;
begin
  with ListBox1 do
    for I := 0 to (Items.Count - 1) do
      NeuroNet[I].Selected := Selected[I];
  ModalResult := mrOK;
end;

procedure TSelectDialog.SelectAllBtnClick(Sender: TObject);
var I: Integer;
begin
  with ListBox1 do
    for I := 0 to (Items.Count - 1) do
      NeuroNet[I].Selected := True;
  ModalResult := mrOK;
end;

end.



